      program reform_rot

!.... REFORMAT OUTPUT FROM ROTATE

!.... 2018 JUN - REMOVED BOB'S VARIABLE Q.  NOW READ SPECTRUM AND 
!                CONTINUUM FLUXES EXPLICITLY
!.... 2017 JUL - CHANGED THE recl OF ALL FILES FROM BYTES TO 4-BYTE WORDS
!.... 2014 MAY - CHANGED module_atlas_dimensions TO module_code_dimensions

      use code_dimensions,    only: max_mu
      use physical_constants, only: pi4
      use var_types

      implicit none

!------------------------ reform_rot VARIABLES -------------------------

      character(len=74) :: title

      integer(in_type) :: i_wl
      integer(in_type) :: len_spec
      integer(in_type) :: n_edge
      integer(in_type) :: n_lines
      integer(in_type) :: n_mu
      integer(in_type) :: nv

      logical :: if_int
      logical :: if_sflux

      real(re_type) :: flux_cont
      real(re_type) :: flux_spec
      real(re_type) :: glog
      real(re_type) :: resolu
      real(re_type) :: spec_ratio
      real(re_type) :: surf_mu(max_mu)
      real(re_type) :: teff
      real(re_type) :: v_rot
      real(re_type) :: w
      real(re_type) :: wlbeg

!------------------------ reform_rot EXECUTION -------------------------

      open(unit = 6, file = 'reform_rot.print', status = 'new',
     &     action = 'write', form = 'formatted')
      open(unit = 9, file = 'rotate.file9', status = 'old',
     &     action = 'read', form = 'unformatted')
      read(9) teff, glog, title, wlbeg, resolu, len_spec,
     &        if_int, if_sflux, n_mu, surf_mu(1:n_mu), n_edge, n_lines,
     &        v_rot, nv

      spec_ratio = 1.0d0 + 1.0d0 / resolu

      write(6, '(a, a /
     &           a, i7, a, f7.4 /
     &           a, f10.1, a /
     &           a, i8 /
     &           a, i8, a /
     &           a, i8)')
     &   "# title: ", trim(title),
     &   "# teff =", int(teff), " K,   log g =", glog,
     &   "# beginning wavelength =", wlbeg, " nm",
     &   "# resolution = lambda/(delta lambda) =", int(resolu),
     &   "# spectrum length =", len_spec, " points",
     &   "# number of lines =", n_lines

      if(if_sflux) then
         write(6, '(a /
     &              a, a7, t14, a, t26, a, t36, a, t48, a /
     &              a)')
     &      "#",
     &      "#", "POINT", "WL(nm)", "FLUX", "CONTINUUM", "RESID",
     &      "#"

         do i_wl = 1, len_spec
            w = wlbeg * spec_ratio**(i_wl - 1)
            read(9) flux_spec, flux_cont
            write(6, '(i8, f12.4, 2es12.3, f8.3)') i_wl, w,
     &         pi4 * flux_spec, pi4 * flux_cont, flux_spec/flux_cont
         end do

      end if

      close(unit = 6)
      close(unit = 9)

      end program reform_rot

!************** E N D  P R O G R A M  R E F O R M_ R O T ***************
